package com.picfun.bt_freqanalizer2;

import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Context;
import android.content.Intent;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.text.SpannableStringBuilder;
import android.view.Gravity;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;


@SuppressLint({ "HandlerLeak", "DrawAllocation" })
public class FreqAnalizer2 extends Activity {
	/**** クラス定数宣言定義 ****/
	public static final int CONNECTDEVICE = 1;
	public static final int ENABLEBLUETOOTH = 2;
	// Bluetoothインスタンス定数
	private BluetoothAdapter BTadapter;
	private BluetoothClient BTclient;
	// バッファ、一般変数定義
	private byte[] RcvPacket = new byte[64];			// 受信バッファ
	private byte[] SndPacket = new byte[64];			// 送信バッファ	
	private int[] DataBuffer = new int[1024];			// Y軸グラフ用バッファ
	private int[] DispX = new int[1024];				// X軸グラフ用バッファ
	private long Frequency, FixFrequency;
	private int i, BlockCounter, State, temp, Sweep;
	private float Level;
	// クラス変数、定数の宣言
	private final static int WC = LinearLayout.LayoutParams.WRAP_CONTENT;
	private static Button select, start, fixfreq;	
	private static TextView text, text0, text1,text10, text11, text12;
	private static EditText setfreq;
	private static MyView graph;
	Context context = this;
	
	/************** 最初に実行するメソッド **************************/
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);  
        requestWindowFeature(Window.FEATURE_NO_TITLE);
		// フルスクリーンの指定
		getWindow().clearFlags(WindowManager.LayoutParams.FLAG_FORCE_NOT_FULLSCREEN);
		getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);          
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
        /*** レイアウト定義　*******/     
        LinearLayout layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.HORIZONTAL);
        setContentView(layout); 
        	// サブレイアウト
        	LinearLayout layout2 = new LinearLayout(this);
            layout2.setOrientation(LinearLayout.VERTICAL);
            layout.setBackgroundColor(Color.BLACK);            
            layout2.setGravity(Gravity.CENTER); 
             	// 見出しテキスト表示             
    	        text = new TextView(this);
    	        text.setLayoutParams(new LinearLayout.LayoutParams(385,WC));
    	        text.setTextSize(23f);
    	        text.setTextColor(Color.MAGENTA);
    	        text.setText(" 周波数特性測定");
	        layout2.addView(text);
    	        // 接続ボタン作成
    	    	select = new Button(this);
    	    	select.setBackgroundColor(Color.CYAN);
    	    	select.setTextColor(Color.BLACK);
    	    	select.setTextSize(20f);
    	    	select.setText("端末接続");
    	    	LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(240, 85);
      	    	params.setMargins(0,20, 0,20);   	    	
    	    	select.setLayoutParams(params);
	    	layout2.addView(select);
	    		// 接続結果表示テキスト
	    		text0 = new TextView(this);
	    		text0.setTextColor(Color.WHITE);
	    		text0.setTextSize(17f);
	    		text0.setLayoutParams(new LinearLayout.LayoutParams(240,85));
	    		text0.setText("接続待ち");
    		layout2.addView(text0);
    	        // 開始ボタン作成
    	    	start = new Button(this);
    	    	start.setBackgroundColor(Color.YELLOW);
    	    	start.setTextColor(Color.BLACK);
    	    	start.setTextSize(20f);
    	    	start.setText("スイープ");  	    	
    	    	start.setLayoutParams(params);
	    	layout2.addView(start);
    	    	// 周波数設定エディタボックス生成
    	    	text10 = new TextView(this);
    	    	text10.setTextColor(Color.WHITE);
    	    	text10.setTextSize(20f);
      	        text10.setLayoutParams(new LinearLayout.LayoutParams(350,80));
      	        text10.setText(" 設定周波数(Hz)");
  	        layout2.addView(text10);
    	    	setfreq = new EditText(this);
     	    	setfreq.setTextColor(Color.WHITE); 
     	    	setfreq.setBackgroundColor(Color.BLACK);
     	    	setfreq.setLayoutParams(new LinearLayout.LayoutParams(240, 80));   	    	
    	    	setfreq.setGravity(Gravity.CENTER);    	    	
    	    	setfreq.setTextSize(25f);    	    	
    	    	setfreq.setText("1000", EditText.BufferType.NORMAL);
	    	layout2.addView(setfreq);

    	    	// 固定出力ボタン生成
    	    	LinearLayout.LayoutParams params1 = new LinearLayout.LayoutParams(240, 85);	    	
    	    	params1.setMargins(0, 5, 0, 0);
    	    	fixfreq = new Button(this);
    	    	fixfreq.setTextColor(Color.BLACK);    	    	
    	    	fixfreq.setBackgroundColor(Color.GREEN);
     	    	fixfreq.setText("固定出力");
     	    	fixfreq.setTextSize(20f);
    	    	fixfreq.setLayoutParams(params1);
	    	layout2.addView(fixfreq);
    	    	
    	    	// 測定レベル表示テキストボックス生成
    	    	LinearLayout.LayoutParams params2 = new LinearLayout.LayoutParams(330, WC);	    	
    	    	params2.setMargins(0, 20, 0, 0);	    	
    	    	text11 = new TextView(this);
      	    	text11.setTextColor(Color.WHITE);  	    	
    	    	text11.setTextSize(20f);
    	    	text11.setLayoutParams(params2);
      	        text11.setText(" 測定レベル(dB)");
  	        layout2.addView(text11);
      	        
    	    	text12 = new TextView(this);
    	    	text12.setTextSize(25f);
    	    	text12.setGravity(Gravity.CENTER);     	    	
       	    	text12.setTextColor(Color.GREEN);    	    	
      	        text12.setLayoutParams(new LinearLayout.LayoutParams(100,60));
      	        text12.setText("12.3456");
  	        layout2.addView(text12); 	    	 	    	
 	        	
  	        // デバッグ用メッセージ
       	        LinearLayout.LayoutParams params4 = new LinearLayout.LayoutParams(330,WC); 
    	    	params4.setMargins(5, 70, 0, 0);       	        
    	    	text1 = new TextView(this); 
        	   	text1.setTextColor(Color.LTGRAY);    	    	
    	    	text1.setTextSize(14f);
      	        text1.setLayoutParams(new LinearLayout.LayoutParams(330,WC));
      	        text1.setText("メッセージ No1 ");
   	        	text1.setLayoutParams(params4);     	        
  	        layout2.addView(text1);
        layout.addView(layout2);
	        // グラフ表示領域指定
	        graph = new MyView(this);
	        layout.addView(graph); 
        // スイッチイベント組み込み
	    select.setOnClickListener((OnClickListener) new SelectExe());
        start.setOnClickListener((OnClickListener) new startMesure());
        fixfreq.setOnClickListener((OnClickListener) new fixfreqOut());
        
		// Bluetoothが有効な端末か確認
		BTadapter = BluetoothAdapter.getDefaultAdapter();
		if (BTadapter == null) {
			text0.setTextColor(Color.YELLOW);
			text0.setText("Bluetooth未サポート");
		}        

		// データバッファ初期化
    	BlockCounter = 0;		
    	State = 0;
    	for(i=0; i<1024; i++){
			DataBuffer[i] = 0;
			DispX[i] = i;
		}
    } 
    
	/************* アクティビティ開始時（ストップからの復帰時） ***********/
	@Override
	public void onStart() {
		super.onStart();
		if (BTadapter.isEnabled() == false) {		// Bluetoorhが有効でない場合
			// Bluetoothを有効にするダイアログ画面に遷移し有効化要求
			Intent BTenable = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
			// 有効化されて戻ったらENABLEパラメータ発行
			startActivityForResult(BTenable, ENABLEBLUETOOTH);
		}
		else {
			if (BTclient == null) {
				// 有効化ならクライアントクラスを生成しハンドラを生成する
				BTclient = new BluetoothClient(this, handler);
			}
		}
	}
	/********* アクティビティ再開時（ポーズからの復帰時） ****************/
	@Override
	public synchronized void onResume() {
		super.onResume();
		// 特に処理なし
	}
	/****** アクティビティ破棄時 **********/
	@Override
	public void onDestroy() {
		super.onDestroy();
		if (BTclient != null) {
			BTclient.stop();
		}
	}
	/************ 遷移ダイアログからの戻り処理 *********************/
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		switch (requestCode) {
			// 端末選択ダイアログからの戻り処理
			case CONNECTDEVICE: 							// 端末が選択された場合
				if (resultCode == Activity.RESULT_OK) {
					String address = data.getExtras().getString(DeviceListActivity.DEVICEADDRESS);
					// 生成した端末に接続要求
					BluetoothDevice device = BTadapter.getRemoteDevice(address);
					BTclient.connect(device);				// 端末へ接続
				}
				break;
			// 有効化ダイアログからの戻り処理
			case ENABLEBLUETOOTH: 							// Bluetooth有効化の場合
				if (resultCode == Activity.RESULT_OK) {
					// 正常に有効化できたらクライアントクラスを生成しハンドラを生成する
					BTclient = new BluetoothClient(this, handler);
				}
				else {
					Toast.makeText(this, "Bluetoothのサポートなし", Toast.LENGTH_SHORT).show();
					finish();
				}
		}
	}
	
    /********* 接続ボタンイベントクラス ****************/
    class SelectExe implements OnClickListener{
    	public void onClick(View v){
 			// デバイス検索と選択ダイアログへ移行    		
    		Intent Intent = new Intent(FreqAnalizer2.this, DeviceListActivity.class);
 			// 端末が選択されて戻ったら接続要求するようにする
 			startActivityForResult(Intent, CONNECTDEVICE);   	    		
    	}
    }
	/********** BT端末接続処理のハンドラ、戻り値メッセージごとの処理実行 ***************************/
	private final Handler handler = new Handler() {
		// ハンドルメッセージごとの処理
		@Override
		public void handleMessage(Message msg) {
			switch (msg.what) {
			case BluetoothClient.MESSAGE_STATECHANGE:
					switch (msg.arg1) {
						case BluetoothClient.STATE_CONNECTED:
							text0.setTextColor(Color.GREEN);
							text0.setText("接続完了");
							break;
						case BluetoothClient.STATE_CONNECTING:
							text0.setTextColor(Color.WHITE);
							text0.setText("接続中");
							break;
						case BluetoothClient.STATE_NONE:
							text0.setTextColor(Color.RED);
							text0.setText("接続失敗");
							break;
					}
					break;
				// BT受信処理
			case BluetoothClient.MESSAGE_READ:
					RcvPacket = (byte[])msg.obj;
					Process();
					break;
			}
		}
	}; 
	
    /********* スイープボタンイベントクラス ****************/
    class startMesure implements OnClickListener{
    	public void onClick(View v){
    		if(State == 0){								// Stateが0のときのみ即実行
    			Sweep = 0;
	    		BlockCounter = 0;						// 格納ポインタリセット
	    		Frequency = 10;							// スイープ開始周波数
	     		SndPacket[0] = 0x53;					// S
	    		SndPacket[1] = 0x54;					// T
	    		SndPacket[2] = 0x45;					// E
				BTclient.write(SndPacket); 				// 送信実行
	    		State = 2;								// 初期ステートへ	
    		}
    		else										// Stateが0以外のときはフラグオンのみ
    			Sweep = 1;								// スイープボタンフラグオン
    	}    		
    }
    /**********  固定出力ボタンイベントクラス ****************/
    class fixfreqOut implements OnClickListener{
    	public void onClick(View v){
    		// 設定周波数の取得
    		if(State == 0){										// Stateが0のときのみ有効
	    		SpannableStringBuilder temb = (SpannableStringBuilder)setfreq.getText();
	    		FixFrequency = Long.parseLong(temb.toString());
	    		if(FixFrequency < 10000000){
					Frequency = FixFrequency;					// 固定周波数に置き換え
					SndPacket[0] = 0x53;						// S
					SndPacket[1] = 0x4E;						// N
					SndPacket[2] = (byte)Frequency;				// 周波数を送信バッファにセット
					SndPacket[3] = (byte)(Frequency >>> 8);		// バイト単位で4バイト
					SndPacket[4] = (byte)(Frequency >>> 16);
					SndPacket[5] = (byte)(Frequency >>> 24);
					SndPacket[6] = 0x45;						// E
					BTclient.write(SndPacket); 					// 送信実行
					text0.setText("固定出力制御");
					text1.setText(Long.toString(Frequency));	// 周波数表示		
		     		State = 1;									// 受信ステートへ
	    		}
    		}
    	}    		
    } 
    
   
	/******************* データ受信処理メソッド ************************/
	public void Process(){
		/*** 受信チェック ***/
		if(RcvPacket[0] == 0x4D){											// M
			switch(State) {
				case 0:			// Idle 
					
					break;
				case 1:				// 固定周波数モードの場合 レベル受信と表示			
					// レベル入力処理
					if(RcvPacket[1] == 0x4E){								// N
						temp = (RcvPacket[2] & 0x7F) + RcvPacket[3]*256;	// レベルデータ取得
						if((RcvPacket[2] & 0x80) != 0)						// 符号の処理
							temp += 128;
						// レベルの実機補正と格納
						// 実機測定　0dB=660  -20dB=500　傾き80/10dB
						Level = (float)(0.125*temp - 82.5);					// デシベルに変換
						handler.post(new Runnable(){						// 測定レベルのテキスト表示
							public void run(){
//								text12.setText(Float.toString(Level));		// 表示	
								text12.setText(Integer.toString(temp));		// 実機調整用								
							}
						});
					}
					State = 0;												// アイドルへ
					break;
				case 2:			// スイープモードの最初
					// OK受信確認
					if((RcvPacket[2] == 0x4F)&& (RcvPacket[3] == 0x4B)){	// OK確認
						text0.setText("スイープ開始");
						/* 最初の周波数出力 **/
						SndPacket[0] = 0x53;								// S
						SndPacket[1] = 0x4E;								// N
						SndPacket[2] = (byte)Frequency;						// 周波数を送信バッファにセット
						SndPacket[3] = (byte)(Frequency >>> 8);				// バイト単位で4バイト
						SndPacket[4] = (byte)(Frequency >>> 16);
						SndPacket[5] = (byte)(Frequency >>> 24);
						SndPacket[6] = 0x45;								// E
						BTclient.write(SndPacket); 							// 送信実行  						
						State = 3;											// 次へ
					}
					break;

				case 3:				//スイープモードの一巡
					// レベル入力処理
					if(RcvPacket[1] == 0x4E){								// M
						temp = (RcvPacket[2] & 0x7F) + RcvPacket[3]*256;	// レベルデータ取得
						if((RcvPacket[2] & 0x80) != 0)
							temp += 128;
						// レベルの実機補正とスケール変換後バッファへ格納
						// 実機測定　0dB=660  -20dB=500 　傾き  80/10dB　10dBで150ドット
						DataBuffer[BlockCounter] = (150*(temp - 660))/80;	// バッファへ保存（Y値）
						Level = (float)(0.125*temp -82.5);					// デシベルに変換
						handler.post(new Runnable(){						// 測定レベルのテキスト表示
							public void run(){
								text12.setText(Float.toString(Level));		// 表示	
							}
						});
						// LogスケールのX軸目盛の計算とバッファ保存
						DispX[BlockCounter] = (int)((Math.log10(Frequency)-1)*1500/6);
						if(DispX[BlockCounter] > 1499){						// X軸が右端まで到達したか？
							BlockCounter = 0;								// 終了し最初に戻す
							State = 0;										// 終了としてアイドルへ
						}
						else{
							if(Sweep == 1){									// スイープが途中で押された場合
				    			Sweep = 0;									// スイープボタンフラグオフ
					    		BlockCounter = 0;							// 格納ポインタリセット
					    		Frequency = 10;								// スイープ開始周波数
					     		SndPacket[0] = 0x53;						// S
					    		SndPacket[1] = 0x54;						// T
					    		SndPacket[2] = 0x45;						// E
								BTclient.write(SndPacket); 					// 送信実行
					    		State = 2;									// 初期ステートへ	
							}	
							else{
								// 次の周波数出力　Logスケールの1/10ステップ
								Frequency = Frequency + (long)(Math.pow(10, (int)(Math.log10(Frequency))))/10;
								BlockCounter++;								// ポインタ更新				
								SndPacket[0] = 0x53;						// S
								SndPacket[1] = 0x4E;						// N
								SndPacket[2] = (byte)Frequency;				// 周波数を送信バッファにセット
								SndPacket[3] = (byte)(Frequency >>> 8);		// バイト単位で4バイト
								SndPacket[4] = (byte)(Frequency >>> 16);
								SndPacket[5] = (byte)(Frequency >>> 24);
								SndPacket[6] = 0x45;						// E
								BTclient.write(SndPacket); 					// 送信実行 
								handler.post(new Runnable(){				// 測定レベルのテキスト表示
									public void run(){
										text1.setText(Long.toString(Frequency));// 周波数表示		
									}
								});							
								// データのグラフ表示
								handler.post(new Runnable(){
									public void run(){		
										graph.invalidate();					// データグラフの再表示		
									}
								});
								State = 3;									// 計測繰り返し
							}
						}
					}
					break;			
				default:
					State = 0;												// イベント待ちステートへ
					break;
			}
		}
	}

	/**************** グラフを表示するクラス ******************************/
	class MyView extends View{
		// Viewの初期化とコンストラクタ設定
		public MyView(Context context){
			super(context);

		}
		// グラフ表示実行メソッド
		public void onDraw(Canvas canvas)
		{
			int i, j;
			int xaxis;
 		
	 		super.onDraw(canvas);
	 		//背景色の設定
	 		Paint set_paint = new Paint();
			canvas.drawColor(Color.BLACK); 		
			
			/** 座標の表示 青色で表示**/
			set_paint.setColor(Color.BLUE);
			set_paint.setStrokeWidth(1);
			// 縦軸の表示　10本
			for(i=0; i<6; i++){
				for(j=1; j<10; j++){
					xaxis = (int)(Math.log10(j*Math.pow(10,i))*1500/6);
					canvas.drawLine(35+xaxis, 2, 35+xaxis, 1052, set_paint);
				}
			}
			// 横軸の表示　7本
			for(i=0; i<7; i++){
				canvas.drawLine(35, 2+i*150, 1535, 2+i*150, set_paint);
			}
			// Y軸の0dBラインをシアンで描画
			set_paint.setStrokeWidth(1);   			
			set_paint.setColor(Color.CYAN);
			canvas.drawLine(35, 302, 1535, 302, set_paint);
			//外枠を白色で描画
			set_paint.setColor(Color.WHITE);
			set_paint.setStrokeWidth(2);   		
			canvas.drawLine(35, 2, 35, 1052, set_paint);
			canvas.drawLine(1535, 2, 1535, 1052, set_paint);
			canvas.drawLine(35, 2, 1535, 2 ,set_paint);
			canvas.drawLine(35, 1052, 1535, 1052, set_paint);			
			/* 軸目盛の表示 */
			set_paint.setAntiAlias(true);
			set_paint.setTextSize(22f);					// 文字サイズ指定
			set_paint.setColor(Color.WHITE);			// 文字色指定
			// X座標目盛
			for(i=0; i<7; i++){
				switch(i){
					case 0:
						canvas.drawText("10", (int)(Math.log10(Math.pow(10, i))*1500/6)+21, 1080, set_paint);   			
						break;
					case 1:
						canvas.drawText("100", (int)(Math.log10(Math.pow(10, i))*1500/6)+17, 1080, set_paint);   			
						break;
					case 2:
						canvas.drawText("1k", (int)(Math.log10(Math.pow(10, i))*1500/6)+21, 1080, set_paint);   			
						break;
					case 3:
						canvas.drawText("10k", (int)(Math.log10(Math.pow(10, i))*1500/6)+20, 1080, set_paint);   			
						break;
					case 4:	
						canvas.drawText("100k", (int)(Math.log10(Math.pow(10, i))*1500/6)+13, 1080, set_paint);   			
						break;
					case 5:	
						canvas.drawText("1M", (int)(Math.log10(Math.pow(10, i))*1500/6)+15, 1080, set_paint);   			
						break;
					case 6:
						canvas.drawText("10M", (int)(Math.log10(Math.pow(10, i))*1500/6)-10, 1080, set_paint);   			
						break;
					default:
						break;
				}
			}
 			// Y座標目盛
			for(i=-50; i<=20; i+=10){
				canvas.drawText(Integer.toString(i), 0, 315-i*15, set_paint);
			}
			set_paint.setColor(Color.GREEN);						// グラフY軸見出し色設定
			canvas.drawText("周波数(Hz)", 400, 1100, set_paint); 	// 軸見出し指定		
			canvas.drawText("dB", 0, 250, set_paint); 				// Y軸の単位表示
			// 実際のグラフの表示　　
 			set_paint.setColor(Color.RED);       		
 			for(i=2; i<BlockCounter; i++){
 				canvas.drawLine(DispX[i-1]+35, 302-DataBuffer[i-1], DispX[i]+35, 302-DataBuffer[i], set_paint);
  			}
		}
	}
}
